---
title: Create metric collection
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Experiments
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

{% callout %}
# Important note for users on the following Datadog sites: app.ddog-gov.com, us2.ddog-gov.com

{% alert level="danger" %}
This product is not supported for your selected [Datadog site](https://docs.datadoghq.com/getting_started/site.md). ({% placeholder "user-datadog-site-name" /%}).
{% /alert %}

{% /callout %}

# Create metric collection{% #create-metric-collection %}

{% tab title="v2" %}

| Datadog site      | API endpoint                                                             |
| ----------------- | ------------------------------------------------------------------------ |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/experiments/metric-collections |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/experiments/metric-collections |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/experiments/metric-collections      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/experiments/metric-collections      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/experiments/metric-collections  |
| uk1.datadoghq.com | POST https://api.uk1.datadoghq.com/api/v2/experiments/metric-collections |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/experiments/metric-collections     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/experiments/metric-collections |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/experiments/metric-collections |

### Overview

Create metric collection. This endpoint requires the `product_analytics_metrics_write` permission.

OAuth apps require the `product_analytics_metrics_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#experiments) to access this endpoint.



### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                        | Type     | Description                                                                 |
| ------------ | ---------------------------- | -------- | --------------------------------------------------------------------------- |
|              | data [*required*]       | object   | Metric collection resource to create.                                       |
| data         | attributes [*required*] | object   | Name, description, and metric selection for the new collection.             |
| attributes   | description                  | string   | Description of the metric collection.                                       |
| attributes   | is_guardrail                 | boolean  | Whether the collection is designated as a guardrail collection.             |
| attributes   | metrics                      | [object] | Metrics to include in the collection.                                       |
| metrics      | metric_id [*required*]  | uuid     | Identifier of the metric to include in the collection.                      |
| attributes   | name [*required*]       | string   | Display name of the metric collection.                                      |
| data         | id                           | string   | Optional JSON:API resource identifier field.                                |
| data         | type [*required*]       | enum     | Metric collections resource type. Allowed enum values: `metric-collections` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "type": "metric-collections",
    "attributes": {
      "name": "ex-14bb9543f523edde"
    }
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
Response containing the metric collection.

| Parent field | Field                  | Type      | Description                                                                 |
| ------------ | ---------------------- | --------- | --------------------------------------------------------------------------- |
|              | data [*required*] | object    | JSON:API resource containing the metric collection identity and fields.     |
| data         | attributes             | object    | Details of the metric collection.                                           |
| attributes   | created_at             | date-time | Time when this resource was created.                                        |
| attributes   | description            | string    | Text that explains the metric collection.                                   |
| attributes   | is_guardrail           | boolean   | Whether the collection is used for guardrail metrics.                       |
| attributes   | metric_count           | int64     | Number of metrics in this collection.                                       |
| attributes   | metrics                | [object]  | Metrics included in this collection.                                        |
| metrics      | metric_id              | string    | ID of the metric represented by this entry.                                 |
| metrics      | metric_name            | string    | Display name of the metric represented by this entry.                       |
| attributes   | name                   | string    | Display name of the metric collection.                                      |
| attributes   | updated_at             | date-time | Time when this resource was last updated.                                   |
| data         | id [*required*]   | uuid      | ID of the metric collection.                                                |
| data         | type [*required*] | enum      | Metric collections resource type. Allowed enum values: `metric-collections` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created_at": "2026-08-01T12:00:00Z",
      "description": "Metrics reviewed for every checkout experiment.",
      "is_guardrail": false,
      "metrics": [
        {
          "metric_id": "550e8400-e29b-41d4-a716-446655440020",
          "metric_name": "Checkout conversion"
        }
      ],
      "name": "Checkout metrics",
      "updated_at": "2026-08-02T09:30:00Z"
    },
    "id": "550e8400-e29b-41d4-a716-446655440040",
    "type": "metric-collections"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="409" %}
Conflict
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="415" %}
Request body sent with a media type other than application/json or application/vnd.api+json.
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Use a Personal Access Token or Service Access Token export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"  \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/experiments/metric-collections" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer ${DD_BEARER_TOKEN}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "name": "Activation"
    },
    "type": "metric-collections"
  }
}
EOF 

                        
##### 

```go
// Create metric collection returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.ExperimentsCreateMetricCollectionV2Request{
		Data: datadogV2.ExperimentsCreateMetricCollectionV2RequestData{
			Type: datadogV2.EXPERIMENTSPATCHMETRICCOLLECTIONV2REQUESTDATATYPE_METRIC_COLLECTIONS,
			Attributes: datadogV2.ExperimentsCreateMetricCollectionV2RequestDataAttributes{
				Name: "ex-14bb9543f523edde",
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewExperimentsApi(apiClient)
	resp, r, err := api.CreateMetricCollection(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `ExperimentsApi.CreateMetricCollection`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `ExperimentsApi.CreateMetricCollection`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
##### 

```java
// Create metric collection returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ExperimentsApi;
import com.datadog.api.client.v2.model.ExperimentsCreateMetricCollectionV2Request;
import com.datadog.api.client.v2.model.ExperimentsCreateMetricCollectionV2RequestData;
import com.datadog.api.client.v2.model.ExperimentsCreateMetricCollectionV2RequestDataAttributes;
import com.datadog.api.client.v2.model.ExperimentsMetricCollectionV2DTO;
import com.datadog.api.client.v2.model.ExperimentsPatchMetricCollectionV2RequestDataType;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    ExperimentsApi apiInstance = new ExperimentsApi(defaultClient);

    ExperimentsCreateMetricCollectionV2Request body =
        new ExperimentsCreateMetricCollectionV2Request()
            .data(
                new ExperimentsCreateMetricCollectionV2RequestData()
                    .type(ExperimentsPatchMetricCollectionV2RequestDataType.METRIC_COLLECTIONS)
                    .attributes(
                        new ExperimentsCreateMetricCollectionV2RequestDataAttributes()
                            .name("ex-14bb9543f523edde")));

    try {
      ExperimentsMetricCollectionV2DTO result = apiInstance.createMetricCollection(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ExperimentsApi#createMetricCollection");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
##### 

```python
"""
Create metric collection returns "Created" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.experiments_api import ExperimentsApi
from datadog_api_client.v2.model.experiments_create_metric_collection_v2_request import (
    ExperimentsCreateMetricCollectionV2Request,
)
from datadog_api_client.v2.model.experiments_create_metric_collection_v2_request_data import (
    ExperimentsCreateMetricCollectionV2RequestData,
)
from datadog_api_client.v2.model.experiments_create_metric_collection_v2_request_data_attributes import (
    ExperimentsCreateMetricCollectionV2RequestDataAttributes,
)
from datadog_api_client.v2.model.experiments_patch_metric_collection_v2_request_data_type import (
    ExperimentsPatchMetricCollectionV2RequestDataType,
)

body = ExperimentsCreateMetricCollectionV2Request(
    data=ExperimentsCreateMetricCollectionV2RequestData(
        type=ExperimentsPatchMetricCollectionV2RequestDataType.METRIC_COLLECTIONS,
        attributes=ExperimentsCreateMetricCollectionV2RequestDataAttributes(
            name="ex-14bb9543f523edde",
        ),
    ),
)

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
with ApiClient(configuration) as api_client:
    api_instance = ExperimentsApi(api_client)
    response = api_instance.create_metric_collection(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
##### 

```ruby
# Create metric collection returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
end
api_instance = DatadogAPIClient::V2::ExperimentsAPI.new

body = DatadogAPIClient::V2::ExperimentsCreateMetricCollectionV2Request.new({
  data: DatadogAPIClient::V2::ExperimentsCreateMetricCollectionV2RequestData.new({
    type: DatadogAPIClient::V2::ExperimentsPatchMetricCollectionV2RequestDataType::METRIC_COLLECTIONS,
    attributes: DatadogAPIClient::V2::ExperimentsCreateMetricCollectionV2RequestDataAttributes.new({
      name: "ex-14bb9543f523edde",
    }),
  }),
})
p api_instance.create_metric_collection(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" rb "example.rb"
##### 

```rust
// Create metric collection returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_experiments::ExperimentsAPI;
use datadog_api_client::datadogV2::model::ExperimentsCreateMetricCollectionV2Request;
use datadog_api_client::datadogV2::model::ExperimentsCreateMetricCollectionV2RequestData;
use datadog_api_client::datadogV2::model::ExperimentsCreateMetricCollectionV2RequestDataAttributes;
use datadog_api_client::datadogV2::model::ExperimentsPatchMetricCollectionV2RequestDataType;

#[tokio::main]
async fn main() {
    let body = ExperimentsCreateMetricCollectionV2Request::new(
        ExperimentsCreateMetricCollectionV2RequestData::new(
            ExperimentsCreateMetricCollectionV2RequestDataAttributes::new(
                "ex-14bb9543f523edde".to_string(),
            ),
            ExperimentsPatchMetricCollectionV2RequestDataType::METRIC_COLLECTIONS,
        ),
    );
    let configuration = datadog::Configuration::new();
    let api = ExperimentsAPI::with_config(configuration);
    let resp = api.create_metric_collection(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
{% /tab %}
